%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% HW 2, Problem 1 solution key
% Carlos J. Cela, Jan 2012
%
% Calculates and plots B field from a circular coil.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
clear all
close all

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Calculate dl around coil. This is done by 
% calculating and storing the coordinates of
% each point
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
p = calculateCoilPoints();

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Verify geometry of coil and direction of 
% current are correct.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
plotCoil(p);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Problem 1 Part 2: Calculate B along line and 
% create a line plot of its magnitude.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
y = 0;
for j=1:0.05:10
  y = y+1;
  % Calculate B components at the point
  [b] = calculateB(p, 0.75, j, 0.75);

  % Calculate and store magnitude
  bmag(y) = sqrt(b(1)^2+b(2)^2+b(3)^2);
end

% Plot now
figure();
plot(1:0.05:10,bmag,'linewidth', 3);
grid on
xlabel('Distance from wire [m]','fontsize',14);
ylabel('|B| [T]','fontsize',14);
title('Problem 1, part 2: |B| field [T]','fontsize',14);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Problem 1 Part 3: Calculate B on a plane and 
% create a plot of its magnitude.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
bmag = [];
x = 0;
for i=-5:0.1:5
  x = x+1;
  z = 0;
  for k=-5:0.1:5
    z = z+1;
    % Calculate B components at the point
    [b] = calculateB(p, i, 5, k);

    % Calculate and store magnitude
    bmag(z,x) = sqrt(b(1)^2+b(2)^2+b(3)^2);
  end
end

% Plot now
figure();
imagesc(bmag);

% Flip Y-axis of image (by default this 
% type of plot is upside-down)
set(gca,'YDir','normal');

axis square
colorbar
grid on
xlabel('X-axis [m]','fontsize',14);
ylabel('Z-axis [m]','fontsize',14);
title('Problem 1, part 3: |B| field at Y=5 plane [T]','fontsize',14);
set(gca,'XTick',[1 25 50 75 100]);
set(gca,'XTickLabel','-5|-2.5|0|2.5|5');
set(gca,'YTick',[1 25 50 75 100]);
set(gca,'YTickLabel','-5|-2.5|0|2.5|5');

