%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% HW 2, Problem 1 solution key
% Carlos J. Cela, Jan 2012
%
% Verifies the routines to calculate the B field magnitude 
% againt the canonical case of a B field generate by a long wire. 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
clear all
close all

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Create long wire segment along z-axis
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
z = 0;
for k = -10:0.1:10
  z = z+1;
  p(z,:) = [0 0 k];
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Numerically calculate B along line
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
y = 0;
for j=0.3:0.05:2
  y = y+1;
  % Calculate B components at each point
  [b] = calculateB(p, 0, j, 0);

  % Calculate and store magnitude
  bmagn(y) = sqrt(b(1)^2+b(2)^2+b(3)^2);
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Analytically calculate the solution for 
% infinite wire db = mu0*I/(2*pi*r)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
y = 0;
mu0 = 4*pi*1e-7;
for j=0.3:0.05:2
  y = y+1;

  % Calculate B components at each point
  bmag(y) = mu0*1/(2*pi*j);

enddb = mu0*I/(2*pi*r)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Plot now
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
figure();
plot(0.3:0.05:2,bmag,'k','linewidth',4);
hold on
plot(0.3:0.05:2,bmagn,'rs','markersize',10);
hold off
grid on
legend('Analytical solution','Numerical solution');
xlabel('Distance from wire [m]');
ylabel('|B| [T]');

